### AUTHOR, CONTACT, VERSION, DATE ###

The Python scripts in the folder "root" are all provided by Bettina Greese.
For questions and comments please email me (bettina.greese@thep.lu.se).
The current code version is number 35 (seen in "v35" in the main folder name).
Last edited 2015-07-21.

### GETTING STARTED ###

Setting paths:

Before doing anything else, edit the paths to the Organism simulator folder and to the folder where the output of these scripts should be saved. They are found in the functions <orgpath> and <outpath> in the package <simfiles> and then in the module <simsettings.py>.

### STRUCTURE OF THE CODE ###

Top level folder:

The main scripts to work with are in the top level folder called <rop_code_vxx> (xx is the current version number), and start with "run_". There is one script to make all files that are needed for simulations on one template (<run_simfiles.py>). Then, several scripts are provided that run simulations, either just for one parameter set (<run_singlesim.py>) or for several sets that represent some sort of variation (e.g. <run_parvarsim.py>). Furthermore, several other scripts are used to make plots from simulation results and present these in pdf summaries (<run_singleplots.py>, <run_multiplots.py>, <run_multicomp.py>). 

Packages:

The subfolders are all packages for the Python code, and they contain modules grouped by their function. Of particular interest for the user is the package <inputdata> that contains modules where the properties of the template (i.e. cell geometries and neighbourhood relationships) and the parameters (for reactions and also the simulations) are set (see below for details).


### FOLDER STRUCTURE GENERATED BY THE CODE ###

The scripts produce two main folders, one for the simulation data (called <simu_vxx>) and one for the summarized results (called <results_vxx>). Due to my personal arrangement, these two folder appear on the same level as the folder <root>. [It is planned for the future to allow individual setting of the path.] In the following, the subfolder structure is eplained, what the values appearing in them actually mean is explained later.

Results folder:

The folder <results_vxx> will contain one subfolder for each project, e.g. <default> or <parvar_so>. Each project folder will contain sets of files that belong together and have almost the same name, containing the cell and auxin templates and the discretization and a running number. The first file contains a list of paths to the simulation result in plain text format, e.g. <singleL100_single1_50_1_1_parvar1_so_1.txt>. The other files are pdfs with a summary of parameters and other settings and the results plots, e.g. <singleL100_single1_50_1_1_parvar1_so_1_comp.pdf>. In case of the default project, there is only one simulation included, while in all other projects, several simulations are compared.

Simulations folder:

The folder <simu_vxx> will contain one subfolder for each combination of cell and auxin template, e.g. <singleL100_single1>. This, in turn, will contain one subfolder for each combination of the discretization and the initial concentration of auxin, e.g. <50_1_1_A_0.0>. This will contain one subfolder called <template>, one subfolder for each set of auxin parameters used and one subfolder for each mode of ROP simulations (dynamic or conserved) and the initial concentrations of active and inactive ROP, e.g. <dyna_R_0.0_0.0>. To remember the order in which the auxin parameter values appear in these names, there is an (empty) file with the names of the auxin parameters, i.e. <Da__Def__Din__Dw__Taa__Tap__pqc__q__si__so>. Then, each parameter folder has one subfolder for each set of stopping criteria for the simulations, e.g. <Asim_100.0_60>. And this - finally - contains the simulation files and the result, e.g. the file <rop.final>. The subfolders of the ROP folder are organized in analogy to those of the corresponding auxin folder. The (empty) file with the names of the ROP parameters is then <Du__Dv__a__b__c__k1__k2__k3__k4__r__s>.
In summary, the hierarchy for the given example is: 
<simu_vxx><singleL100_single1><50_1_1_A_0.0><xxx_xxx_xxx><Asim_100.0_60>.
This may look complicated at first, but it enables the code to check if a simulation for certain settings have been performed before and then reuse the result and hence save time.


### SCRIPTS AND ARGUMENTS ###

Executable script:

For each script, before it is run for the first time, it needs to be made executable. In the terminal, type the following line, for example:
chmod +x run_simfiles.py

Arguments:

The script use arguments as pairs of flags (with a dash at the beginning) and values (no dash). Possible arguements are the following (not all needed for all scripts), where the letter in brackets can be used as an abbreviation.

-model (-m): Integer that can be 0 (= only auxin model) or between 1 and 5 (= including ROP model), where 1 = combined (auxin induction and ROP autocatalysis multiplied in one term), 2 = separate (auxin induction and ROP autocatalysis in two terms), 3 = auxinind (only auxin induction), 4 = autocat (only ROP autocatalysis).  

-cell (-c): String with name of cell template, e.g. singleL100, which is a single cell that has no lateral apoplast and is 100 um long, or fileVarL2, which is a file of cells with increasing cell lengths and no lateral apoplast. This information is needed to make the .init file for Organism.

-auxin (-a): String with name of auxin template, e.g. single1, which is a single cell setup, i.e. PIN at the apical side and AUX1 at all sides, or epid1, which is the corresponding setup in a cell file.

-variation (-v): String with name of variation that is allowed for chosen script, e.g. so (parameter name) in case of run_parvarsim.py.

-discret (-d): List with three integers that represent the number of compartments for discretization in x, y, z direction, e.g. [50,1,1]. Note that no blank spaces are allowed between the numbers. The default for this is -d [50,1,1], which implies that this argument is optional.

-initial (-i): List with three floats that represent the initial values for the concentrations of auxin, active ROP, inactive ROP, e.g. [0.0,0.0,0.0]. Note that no blank spaces are allowed between the numbers. The default for this is -i [0.0,0.0,0.0], which implies that this argument is optional. 


### SCRIPT FOR MAKING TEMPLATES ###

The script <run_simfiles.py> makes the "template", i.e. it generates the files needed for the simulation, and also a pdf that illustrates some aspects of the cell and auxin templates. These files are stored in:
<simu_vxx><singleL100_single1><50_1_1_A_0.0><template>.

Here is an example how to run the template script:
./run_simfiles.py -c singleL100 -a single1

Note that the script <run_simfiles.py> has to be run for each different cell template, auxin template, discretization and initial conditions. If only model parameters are changed, it is not needed to run it again.


### HOW TO MAKE A TEMPLATE WITH SPECIFIC PROPERTIES ###

It is highly recommended to NOT CHANGE any given templates but to copy the sections of the code, give a new template name and then adjust the settings. This makes sure that all simulations with the same template names have actually used the same settings. 

Cell templates:

The cell templates are defined in the function <celltempl> in the module <cells.py> in the package <inputdata>. The following settings are done for each case (also see comments in the file): 
- wall thickness, 
- lengths of cells in x and y direction (along the root and radially outward), 
- number of cells in the z direction (circumference of the root) that are modelled and that are assumed (needed for calculation of cell volume), 
- number of columella and quiescent center (QC) cells, 
- the type of source and sink. 
When more than one cell size is given for the y direction, the template is considered to have layers of different tissues.

Auxin templates:

The auxin templates are defined in the function <auxintempl> in the module <neighs.py> in the package <inputdata>. The following settings are done for each case (also see comments): 
- location of PINs and AUX1 in general and in the QC and the columella, 
- location and relative strength of lateral PINs, 
- areas for weakening of apical/basal PINs, 
- flip of PINs, 
- presence of AUX1 in parts of some layers, 
- number of source and sink cells. 
Most of these settings are given as one key word or index per layer.

So, to make your particular template, add sections to <cells.celltempl> and <neighs.auxintempl> and then execute <run_simfiles.py> as described above. You will find the resulting files in the folder 
<simu_vxx><celltemplname_auxintemplname><50_1_1_A_0.0><template>
if you choose default discretization and initial conditions. Otherwise, the folder above <template> will be called slightly different.


### SCRIPTS FOR SINGLE SIMULATION AND PLOTS ###

When the files have been made for a particular cell template, auxin template, discretization and initial conditions, the simulation can be run (for the default parameter settings) and afterwards the results can be plotted.

Here is an example how to run the script for a single parameter set:
./run_singlesim.py -m 1 -c singleL100 -a single1

And then plot the results:
./run_singleplots.py -m 1 -c singleL100 -a single1

So, there are always up to three scripts to be run: Making the template, running the simulation, plotting the results.


### PROJECT SIMULATION SCRIPTS ###

to be written...


### SCRIPTS FOR PLOTS AND PRESENTATIONS ###

to be written...



